<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>BehaviorUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/xtend/BehaviorUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.xtend;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Behavior;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.BehavioredClassifier;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Constraint;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.OpaqueBehavior;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.OpaqueExpression;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterDirectionKind;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Transition;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/xtend/BehaviorUtil.html">BehaviorUtil</a> {
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DEFAULT_LANGUAGE = <span class="jxr_string">"C++"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> set(Behavior behavior, String selectLanguage, String textblock) {
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  		<strong class="jxr_keyword">if</strong> (behavior instanceof OpaqueBehavior) {
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  			OpaqueBehavior ob = (OpaqueBehavior) behavior;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  			<strong class="jxr_keyword">if</strong> (ob.getLanguages().size() == 0) {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  				ob.getLanguages().add(DEFAULT_LANGUAGE);
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  				ob.getBodies().add(textblock);
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  			}
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  				<strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  				<strong class="jxr_keyword">for</strong> (String language : ob.getLanguages()) {
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  					<strong class="jxr_keyword">if</strong> (selectLanguage.equals(language)) {
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  						<strong class="jxr_keyword">if</strong> (i &lt; ob.getBodies().size()) {
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  							ob.getBodies().set(i, textblock);
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  						}
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  						<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  					}
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  				}
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  			}
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		}
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	}
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> set(Behavior behavior, String textblock) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  		set(behavior, DEFAULT_LANGUAGE, textblock);
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	}
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> OpaqueBehavior createOpaqueBehavior(BehavioredClassifier clazz, Operation operation) {
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  		OpaqueBehavior ob = (OpaqueBehavior)
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  				clazz.createOwnedBehavior(operation.getName(), UMLPackage.eINSTANCE.getOpaqueBehavior());
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		ob.setSpecification(operation);
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		<strong class="jxr_keyword">return</strong> ob;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	}
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> OpaqueBehavior createOpaqueEffect(Transition transition) {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		OpaqueBehavior ob = (OpaqueBehavior)
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				transition.createEffect(<span class="jxr_string">""</span>, UMLPackage.eINSTANCE.getOpaqueBehavior()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">return</strong> ob;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	}
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> OpaqueExpression createOpaqueExpression(Constraint constraint, String guardCode) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		OpaqueExpression oe = (OpaqueExpression)
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  				constraint.createSpecification(<span class="jxr_string">""</span>, <strong class="jxr_keyword">null</strong>, UMLPackage.eINSTANCE.getOpaqueExpression()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		oe.getLanguages().add(DEFAULT_LANGUAGE);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		oe.getBodies().add(guardCode);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		<strong class="jxr_keyword">return</strong> oe;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	}
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String body(Constraint constraint) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		<strong class="jxr_keyword">if</strong> (constraint.getSpecification() instanceof OpaqueExpression) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			OpaqueExpression oe = (OpaqueExpression) constraint.getSpecification();
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			<strong class="jxr_keyword">if</strong> (oe.getBodies().size() &gt; 0)  {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				<strong class="jxr_keyword">return</strong> oe.getBodies().get(0);
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">return</strong> constraint.getSpecification().stringValue();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * Create an operation with an operation return type</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * @param clazz</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * @param retType</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Operation createOperation(Class clazz, String name, Type retType) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		Operation operation = clazz.createOwnedOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<strong class="jxr_keyword">if</strong> (retType != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			Parameter parameter = operation.createOwnedParameter(<span class="jxr_string">"ret"</span>, retType); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			parameter.setDirection(ParameterDirectionKind.RETURN_LITERAL);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<strong class="jxr_keyword">return</strong> operation;
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String body(Behavior behavior) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		<strong class="jxr_keyword">return</strong> body(behavior, DEFAULT_LANGUAGE);
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String body(Behavior behavior, String selectLanguage) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">if</strong> (behavior instanceof OpaqueBehavior) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			OpaqueBehavior ob = (OpaqueBehavior) behavior;
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 			<strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			<strong class="jxr_keyword">for</strong> (String language : ob.getLanguages()) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 				<strong class="jxr_keyword">if</strong> (selectLanguage.equals(language)) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 					<strong class="jxr_keyword">if</strong> (i &lt; ob.getBodies().size()) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 						<strong class="jxr_keyword">return</strong> ob.getBodies().get(i);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 					}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		}
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 	}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
